package esercitazione4.binarytrees;

import esercitazione3.trees.DinastyTree;

public class BinaryTreeVisits {
	
	private static void printTabs(Integer livello){
		for (int i = 0; i < livello; i++) {
			System.out.print("\t");
		}
	}
	
	public static void print(BinaryTree tree, Integer level, String label){
		
		printTabs(level);
		
		if (tree == null)
			System.out.println("-");
		else {
			System.out.println(label + tree.getValue() + "(" + tree.getNodesInTree() + ")");
		
			print(tree.getLeftChild(), level + 1, "L:");
			print(tree.getRightChild(), level + 1, "R:");	
		}
	}
	
	public static Integer addNumberOfNodes(BinaryTree bt){

	Integer numberOfNodes = 0;
	
	if (bt != null)	{		
		numberOfNodes = addNumberOfNodes(bt.getLeftChild()) + addNumberOfNodes(bt.getRightChild()) + 1;
		bt.setNodesInTree(numberOfNodes);
	}
	
	return numberOfNodes;
	}
	
	public static void deleteLeftLeavesEqualToParent(BinaryTree bt){
		
		if (bt != null) {
			BinaryTree lChild = bt.getLeftChild();
		
			if (lChild != null){
				if (lChild.getValue().equals(bt.getValue()) && lChild.isLeaf())
					bt.deleteLeftSubTree();
			}
			
			deleteLeftLeavesEqualToParent(bt.getLeftChild());
			deleteLeftLeavesEqualToParent(bt.getRightChild());
		}
	}
	
	
	public static void invert(BinaryTree bt){
		
		if (bt != null) {
			
			BinaryTree tmp = bt.getLeftChild();
			bt.setLeftChild(bt.getRightChild());
			bt.setRightChild(tmp);
			
			invert(bt.getLeftChild());
			invert(bt.getRightChild());
			
		}
		
	}
	
	
	
}
